#!/usr/bin/python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

import sys
from nas.service import *
from nas.system import get_name_value
from nas.system import set_name_value
from nas import check_public
from ConfigParser import ConfigParser
AFPCONF = '/etc/netatalk/AppleVolumes.default'
SAMBACONF = '/etc/nas/smb.conf'
REALSAMBACONF = '/etc/samba/smb.conf'

def autoremove():
    dev = "/dev/%s" % sys.argv[1]
    os.system("umount -l %s" % dev)
    checkdir()
    with open('/etc/netatalk/AppleVolumes.default','r') as fd:
	while True:
            line = fd.readline()
            if not line:
                break
            if line.startswith("/media"):
                print line
                path = line.strip().split()[0]
                if not os.path.exists(path):
                    checksmbpath(path)
                    print "path = %s" % path
                    rmafpdev(path)
    restartservice('smb', 'smbd', 139)
    restartservice('netatalk', 'afpd', 548)
    
			
def checksmbpath(path):
    cf = ConfigParser()
    cf.read(REALSAMBACONF)
    s = cf.sections()
    name = os.path.basename(path)
    for n in s:
        if n != name:
            continue
        else:
            path = cf.get(n,'path')
            cf.remove_section(n)
            cf.write(open(REALSAMBACONF, 'w'))	

def rmafpdev(path):
    pi = open('/etc/netatalk/AppleVolumes.default')
    lines = pi.readlines()
    open(AFPCONF,"w").write("")
    for x in lines:
        if path not in x:
            open(AFPCONF,'a').write(x)

	
def checkdir():
    found = False
    dirlist = ["/media/%s" % _dir for _dir in os.listdir('/media')]
    for _dir in dirlist:
        dirlist.remove(_dir)
        with open("/proc/mounts", "r") as fd:
            while True:
                line = fd.readline()
                if not line:
                    break
                mountdir = line.split()[1]
                if mountdir == _dir:
                    found = True
                    break
        if found == False:
            try:
                os.system("chattr -i %s" % _dir)
                os.system("rm -rf %s" % _dir)
            except:
                pass

if __name__ == '__main__':
    autoremove()
