﻿$(function(){
	window.App="DiskManager";
	loadLang();
	loadConfig();
	bindEvent();
});


function loadConfig(){
	$.ajax({
		url:window.top.urlpath+'Configurations/System/disk.conf.xml'
		,type:'Get'
		,dataType:'xml'
		,success:function(data){
			window.level=$('raidmode',data).text();
			$("#OK").show();
		}
	})
}


function bindEvent(){
	$("#OK").hide();
	$("#OK").click(autoDisks);
	$("#OPTION").click(showOption);
}


function autoDisks(){
	if(confirm($.l10n.__('DiskManager_alert_autodisks'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/storage/allinone"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,level:window.level
					,fs:'xfs'
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					window.top.loadNASinfo();
					alert('Completed!');
					window.setTimeout(function(){window.win.closeWin();},500);
					window.top.loadApp('MyNAS');
				}
				,error:function(data){
					$("#waiting").hide();
				}
				//,timeout:20000
				
			});
		}
	}
}

function showOption(){
	window.top.DiskManager.showOption();
}