﻿$(function(){
	window.App="Preference";
	loadLang();	
	bindEvent();
	loadData();
});

function bindEvent(){
	$("#REFRESH").click(function(){	loadData();	});
}

//-----------------------------------------------------------------------------------------------------------------------
function loadData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/info"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function parseData(data){
	var d=$(data);	
	var l=window.top.location.protocol+"//"+d.find('register').text()+'.'+window.top.$.l10n.__('global_link_domainname')+'/';
	var a=' <a href="'+l+'" target="_blank">'+d.find('register').text()+'</a>';
	$("#register").html(d.find('register').text()); 
	$("#hostname").html(d.find('hostname').text()); 
	$("#workgroup").html(d.find('workgroup').text());
	l="http://"+d.find('ipaddr:first').text()+'/';
	a=' <a href="'+l+'" target="_blank">'+d.find('ipaddr:first').text()+'</a>';
	$("#ipaddr").html(a);
	$("#vpnip").html(d.find('vpnip').text());
	l="http://"+d.find('upnpaddr').text()+'/';
	a=' <a href="'+l+'" target="_blank">'+d.find('upnpaddr').text()+'</a>';	
	$("#upnpaddr").html(a);
	$("#hwaddr").html(d.find('hwaddr').text());
	$("#version").html(d.find('software').text());
	//$("#package").html(d.find('package').text());
	$("#date").html(d.find('date').text());
	$("#kernel").html(d.find('kernel').text());
	/*var storage=d.find('storage');
	$("#available").html( formatBytes (storage.find('available').text()) );
	$("#used"). html( formatBytes(storage.find('used').text()) );
	$("#usedpercent").html( storage.find('usedpercent').text() );
	$("#blocks").html( formatBytes( storage.find('blocks').text() ) );*/
}

