﻿$(function(){
	layout();
	bindEvent();
});


function layout(){	
	var file=window.win.object;
	if(file.mime==='image'||file.mime==='audio'||file.mime==='video'){
		$('#image').append('<img src="'+file.thumbnail_src+'"/>');
		$('body').layout({ 
			center__paneSelector:"#content"
			,east__paneSelector:"#image"  
			,east__size:128
			,east__spacing_open:0
			,south__paneSelector:"#bottom"  
			,south__size:60
			,south__spacing_open:0
		}); 
	}else{
		$('#image').remove();
		$('body').layout({ 
			center__paneSelector:"#content"
			,south__paneSelector:"#bottom"  
			,south__size:60
			,south__spacing_open:0
		}); 
	}
	showButton();
}

function bindEvent(){
	$("#send").click(send);
	$("#login").click(login);
	$("#logout").click(logout);
	$('#content').change(function(){
		var l=$('#content').val().length;
		$('#count').html(130-l);
	});
}


function send(){
	if($('#content').val().length>130)return;
	$('#waiting').show();
	var file=window.win.object;
	var content=$('#content').val() + file.publish_url;
	var request='/statuses/update'; // '/statuses/upload_url_text';
	WB2.anyWhere(function(W){
		//&url='+url
		W.parseCMD(request+'.json?status='+content, function(sResult, bStatus){
			$('#waiting').hide();
   		 	if(bStatus){
				$('#content').val('');
				$('#count').html('发送成功！');
			}else{
				$('#count').html('发送失败！请重试。');
			}
		},{
    			method: 'post'
		});
	});
}


function login(){
	WB2.login(function(){
		showButton(true);
	});
}
function logout(){
	WB2.logout(function(){
		showButton(false);
	});
}

function showButton(Login){
	if(!Login)Login=WB2.checkLogin()
	if(Login){
		$('#login').hide();
		$('#logout,#send').show();
	}else{
		$('#login').show();
		$('#logout,#send').hide();
	}
}