﻿var HTML5UPLOAD={

init:function (){ 
	$('body').bind('drop', dragdrop);
	$('body').bind('dragover', dragover);
	$('body').bind('dragenter', dragenter);
	$('body').bind('dragleave', dragleave); 	

	HTML5UPLOAD.loaded=true;
	
	function dragover(event){
		//event.stopPropagation();
		//event.preventDefault();
		return false;
	}
	
	function dragenter(event){
		//event.preventDefault();	
		return false;
	}
	
	function dragleave(event){
		return false;
	}
	
	//拖拽进入后
	function dragdrop(event) {
		if(this.tasks&&this.tasks.preparing)return;
		var url;
		var data = event.originalEvent.dataTransfer;
		
		if(!data)return;	
		if ($.browser.mozilla) {
			url=data.getData('text/uri-list');
			event.preventDefault();
			event.stopPropagation();
		}
		else{
			url=data.getData('URL');
			event.returnValue = false;
		}
		dragleave();
		
		if(url&&url.indexOf(window.location.protocol+"//"+window.location.host)==0)return;	
		
		if(!window.top.uploadproxy.path){
			if(window.top.MyNAS.mainWin){ 
				var c=window.top.MyNAS.mainWin.content; 
			}
			else{
				var c=window.top.$('body')[0];
			}
			if(c.$UPLOAD&&c.$UPLOAD.hasClass('enabled'))window.top.uploadproxy.path=c.$curTreeNode[0].path; 
			window.top.uploadproxy.force=false;
		}
		if(window.top.uploadproxy.path&&window.top.uploadproxy.path!=='null'&&window.top.uploadproxy.path!==''){
			if($.browser.chrome&&data.items.length>0&&$.inArray(window.top.uploadproxy.path,['/dav/restore/','/dav/firmware/'])===-1){ 
				HTML5UPLOAD.traverseFileTree(data.items);
			}else{
				HTML5UPLOAD.addTasks(data.files, window.top.uploadproxy.path, window.top.uploadproxy.force, window.top.uploadproxy.fn);
				window.top.uploadproxy={path:null,force:false,fn:null};
			}
		}
		return false;
	}
	
	//this.showWindow();
	

},

//for chrome only 分析本地目录，获取上传
traverseFileTree:function (data, path) {
	path = path || '';
	var entries=[];
	var listEntries=function(entry){
		entry.file(function(file){
			file.fullPath=path+encodeURI(entry.fullPath);
			entries.push(file);
		});
	}
	var readEntries = function(dirReader) {
		dirReader.readEntries (function(results) {
			for(var i=0,l=results.length;i<l;i++){
				var entry = results[i];	
				if (entry.isFile){
					listEntries(entry);
				}else {
					readEntries(entry.createReader());
				}
			};
		});
	};	
	for (var i=0,l=data.length; i<l; i++) {
		var entry = data[i].webkitGetAsEntry();	
		if (entry.isFile){
			listEntries(entry);
		}else {
			readEntries(entry.createReader());
		}
	}	
	var l='';
	//$('#info').html('Reading files: 0');
	var interval=window.setInterval(function(){
		//$('#info').html('Reading files: '+ l);
		if(l===entries.length){
			//$('#info').html();
			window.clearInterval(interval);
			HTML5UPLOAD.addTasks(entries, window.top.uploadproxy.path, window.top.uploadproxy.force, window.top.uploadproxy.fn);
		}
		l=entries.length;
	},200);
},



showWindow:function(fn){
	if(fn)window.top.uploadproxy.fn=fn;
	if(!window.top.MyNAS)window.top.loadApp('MyNAS',function(){window.top.MyNAS.upload();});
	else window.top.MyNAS.upload();	 
},


fileExsit:function(path){
	var list=$("#tasks tr");
	for(var i=0;i<list.length;i++){
		if($("td[_name='target'] div",list[i]).html()==path)return true;
	}
	return false;
},



prepareFiles:function(){
	this.tasks.processed++;
	if(this.tasks.processed>=this.tasks.total){
		this.tasks.preparing=false;
		return;
	}
	var file=this.tasks.files[this.tasks.processed];
	var path=this.tasks.path;
	var fullPath=file.fullPath;
	if(fullPath)fullPath=this.tasks.path+fullPath;
	else fullPath=path+file.name;
	if(file.size>0){
		if(HTML5UPLOAD.fileExsit( fullPath )){
			//alert( $.l10n.__('MyNAS_upload_alert_fileatlist').replace('{0}',file.name));
			HTML5UPLOAD.prepareFiles();
		}else{
			if(this.tasks.force){
				new HTML5UPLOAD.uploadTask(file, path);
				HTML5UPLOAD.prepareFiles();
			}else{
				if(!this.tasks.remember||this.tasks.remember==='no'||this.tasks.remember==='cancel'){
					window.top.System.isFileExist({
						path:encodeURI(fullPath)
						,app:window.top.MyNAS
						,tasks:this.tasks
						,fn:function(){	
							var overwite=true;
							new HTML5UPLOAD.uploadTask(file, path);
							HTML5UPLOAD.prepareFiles();
						}
						,cancel:function(){
							HTML5UPLOAD.prepareFiles();
						}
						,cfm:HTML5UPLOAD.tasks.remember==='cancel'?false:true
					});		
				}else{
					new HTML5UPLOAD.uploadTask(file, path);
					HTML5UPLOAD.prepareFiles();
				}
			}
		}
	}else{
		//alert($.l10n.__('MyNAS_upload_alert_filesize0').replace('{0}',file.name ));
		HTML5UPLOAD.prepareFiles();
	}
},


addTasks:function(files, path, force, fn){ 
	this.showWindow();
	this.tasks={
		files:files
		,path:path
		,force:force
		,preparing:true
		,processed:-1
		,total:files.length
		,fn:fn
	};
	if(window.uploadtimer)window.clearInterval(window.uploadtimer);
	window.uploadtimer=window.setInterval(function(){
		if(HTML5UPLOAD.tasks.preparing)return;
		if(window.top.$("#tasks tr.queuing").length===0){
			window.clearInterval(window.uploadtimer);
			if(window.top.MyNAS)window.top.MyNAS.refreshWin(path);
		}
		else{
			window.top.$("#tasks tr.queuing").each(function(){
				if(!this.task.time)this.task.time=0;
				this.task.time++; 
				$("div.time",this).html(formatTime(this.task.time));
			});
		}
		if(window.top.$("#tasks tr").length===0){
			window.clearInterval(window.uploadtimer);
			window.top.MyNAS.uploadWin.closeWin();
		}
	}
	,1000);
	this.prepareFiles();
},


uploadTask:function(file,path){
	if(!$("#tasks")[0])return;
	if(file.size>1999999999){
		alert($.l10n.__('System_upload_alert_maxfilesize'));
		return;
	}
	this.initTask=function(){
		if(!window.taskID)window.taskID=0;
		window.taskID++;
		this.file=file;
		this.path=path;
		this.name=encodeURIComponent(file.name);
		this.fullPath=file.fullPath;
		this.info={};
		this.length=file.size;	
		$("#tasks")[0].grid.addRow({
			id:'uploadtask'+window.taskID
			,operation:''
			,filename:this.name
			,progress:''
			,filesize:formatBytes(this.length)
			,uploaded:0
			,target:this.path+ (this.fullPath?this.fullPath:this.name)
			,time:'00:00:00:000'
			,speed:''
		});
		var tr=$("#tasks tr#uploadtask"+window.taskID);		
		
		var play=document.createElement("a");
			play.className="icon s12 play";
			play.style.cssText="padding:0;margin:0 5px;";
			play.task=this;	
			$(play).click(function(){
			   this.task.send();
			});
			this.$playButton=$(play);
		var remove=document.createElement("a");
			remove.className="icon s12 remove";
			remove.style.cssText="padding:0;margin:0 5px;";
			remove.task=this;		
		$("td[_name='operation'] div",tr).append(play).append(remove);
		$("td[_name='progress'] div",tr).html("<div class='progressbar' style='padding:0;margin:0;width:100%;'><div style='padding:0;margin:0;'></div><span>0%</span></div>");

		$(remove).click(function(){ this.task.remove();	});	
			
						
		
		
		this.$progressbar=$("td[_name='progress'] div.progressbar div",tr);
		this.$uploaded=$("td[_name='uploaded'] div",tr);
		this.$speed=$("td[_name='speed'] div",tr);
		this.$percentage=$("td[_name='progress'] span",tr);
		this.$time=$("td[_name='time'] div",tr);
		this.$time.addClass("time");
		this.$target=$("td[_name='target'] div",tr);
		this.$task=tr;
		this.$task.addClass("queuing");
		tr[0].task=this;
		if($("#tasks tr.running").length==0)this.send();
	}
	
	//上传
	this.send=function(){ 
		this.$playButton.remove();
		this.$task.addClass("running");
			
		var task=this;
		var request=new XMLHttpRequest();		
		this.request=request;
		

		this.request.upload.onprogress = function(progressEvent){
			var c=progressEvent.lengthComputable;
			if(c){
				var t=progressEvent.total;
				var l=progressEvent.loaded; 
				task.$uploaded.html(formatBytes(l));				
				var p=parseInt((l/t)*100);
				if(p>100)p=100;
				p=p+"%";
				task.$percentage.html(p);
				task.$progressbar.css({width:p}); 
				//task.$speed.html(formatBytes(this.task.v)+'/s');			
			}
		};
		
		
		this.request.onreadystatechange = function(){				
			switch(request.readyState){
					case 4:    
						var apierror=false; 
						var status=request.status;
						
						if(status=='201'||status=='204'||status=='1223'||status=='200'||status=='412'){
							apierror=false;
							if(status=='412')alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status + ' wrong file format!') );		
							if(status=='200')apierror=window.top.checkAPIError(task.request.responseText);
						}
						else{
							apierror=true;
							alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status ) );	
						}

						task.$task.removeClass("running");
						if(HTML5UPLOAD.tasks.fn)HTML5UPLOAD.tasks.fn();
						task.remove(); 
						task.next();
					break;
				}
			}; 
		
		request.open( "POST", task.path+((task.fullPath)?task.fullPath:task.name)  +'?streaming='+(($.browser.msie)?'false':'true') ); 
		request.setRequestHeader('Session', window.top.SessionID);
		request.setRequestHeader('Content-Range', 'bytes 0-' + (task.length-1) + '/'+task.length);	
		request.send(task.file);
	}
	

	
	
	
	//删除任务
	this.remove=function(){
		var bool=true;
		if(this.$task.hasClass("running")){
			if(!confirm($.l10n.__('MyNAS_upload_alert_notcomplete'))){
				bool=false;
			}
		}
		if(bool){
			this.$task.remove();
			this.request=null;
			this.send=function(){};
			if(this.request)this.request.abort();
		}
	}
	
	//继续任务
	this.next=function(){
		if($("#tasks tr.running")>0)return;
		try{$("#tasks tr.queuing")[0].task.$playButton.click();}catch(e){}
	}
	
	//初始化新任务
	this.initTask();
}

}