#!/bin/bash
#
#

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

function mount2afp(){
	afpfile="/etc/netatalk/AppleVolumes.default"
	grep -n $2 $afpfile >> /dev/null
	if [ $? == 1 ];then 
		echo "$1 $2 allow:admin cnidscheme:dbd options:usedots,upriv" >> $afpfile
	fi
}

function mount2smb(){
	smbfile="/etc/samba/smb.conf"
	grep -n $2 $smbfile >> /dev/null
        
	if [ $? == 1 ];then
		echo "[$2]" >> $smbfile
        	echo "comment = Removalbe Deivces" >> $smbfile
		echo "path = $1" >> $smbfile
		echo "public = no" >> $smbfile
		echo "writable = yes" >> $smbfile
		echo "write list = admin" >> $smbfile
		echo "create mask = 0775" >> $smbfile
		echo "valid users = admin" >> $smbfile
        	echo "" >> $smbfile
	fi
}


#delay 1 s
sleep 1

for path in /media/USBCOPY-P{1..9}; do 
if [ -d $path ];then
	afpname=\"${path:7}\"
	smbname=${path:7}  
	mount2afp $path $afpname
	mount2smb $path $smbname
fi
done

for path in /media/USBCOPY; do
if [ -d $path ];then
	iafpname=\"${path:7}\"
	smbname=${path:7}
	mount2afp $path $afpname
	mount2smb $path $smbname
fi
done

#delay 500 ms
usleep 500000

#killall -s SIGHUP afpd
enable=$(chkconfig --list |grep netatalk | awk '{print $5}')

if [ $enable == "3:on" ];then
        service netatalk reload
fi

killall -s SIGHUP smbd

