﻿$(function(){
	window.App="Preference";
	loadLang();	
	bindEvent();
	loadData();
});



//-----------------------------------------------------------------------------------------------------------------------
function bindEvent(){	
	$("#APPLY").click(toApply);
	$("#browse").click(showBrowse);	
	$("#REFRESH").click(loadData);
}



//-----------------------------------------------------------------------------------------------------------------------
function loadData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/usbcopy"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}



function parseData(data){
	$("#folder").val(   syspathToDavpath ( decodeURI ($('USBCOPY_DIR',data).text()  ) ) ); 
}


function toApply(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/usbcopy"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:'/dav'+$("#folder").val()
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function showBrowse(){
	window.top.System.selectDir({
		app:window.top.Preference
		,handler: function(path){
			$("#folder").val(   decodeURI(path) );
		}
	}); 
}